<?php 
			if( function_exists('acf_add_local_field_group') ):

acf_add_local_field_group(array(
	'key' => 'group_56e68cf4e94bc',
	'title' => 'WooCommerce Role Assigner - Amounts configurator',
	'fields' => array(
		array(
			'key' => 'field_56e68da313bb0',
			'label' => 'Role per Amount Spent rules',
			'name' => 'wcra_rules',
			'type' => 'repeater',
			'instructions' => 'Here you can configure role(s) assignement by amounts spent by user during the selected time periods. <strong>Lower ruels</strong> have <strong>higher priority</strong> this is important when you are using the <strong>remove previous roles before assigning the new ones</strong> option.',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'min' => 0,
			'max' => 0,
			'layout' => 'block',
			'button_label' => 'Add new rule',
			'collapsed' => 'field_56e68e1c13bb1',
			'sub_fields' => array(
				array(
					'key' => 'field_56e68e1c13bb1',
					'label' => 'Rule name / id',
					'name' => 'wcra_rule_name_id',
					'type' => 'text',
					'instructions' => 'Type a rule name / id to better identify the rule',
					'required' => 1,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'default_value' => '',
					'maxlength' => '',
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'readonly' => 0,
					'disabled' => 0,
				),
				array(
					'key' => 'field_589f082ef2cc1',
					'label' => 'Unique id',
					'name' => 'wcra_unique_id',
					'type' => 'unique_id',
					'instructions' => 'Ignore this field, is automatically assigned by the plugin once the rule is saved.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
				),
				array(
					'key' => 'field_56f3f6afd33fc',
					'label' => 'Time period type',
					'name' => 'wcra_time_period_type',
					'type' => 'select',
					'instructions' => '<p>You can choose to set multiple fixed time periods (setting start date and end date) or a dynamic period.</p><p>Using the dynamic type you can defined a time range that goes from "now" to the last	<i>n</i> Minutes/Horus/Days/Months/Years where <i>n</i> is the time span. (EX.: Last 3 months, or last 7 days and so on).</p>',
					'required' => 1,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'multiple' => 0,
					'allow_null' => 0,
					'choices' => array(
						'fixed' => 'Fixed period(s)',
						'dynamic' => 'Dynamic period',
					),
					'default_value' => array(
					),
					'ui' => 0,
					'ajax' => 0,
					'placeholder' => '',
					'return_format' => 'value',
				),
				array(
					'key' => 'field_56f3f7dc7b16d',
					'label' => 'Time range span',
					'name' => 'wcra_time_amount',
					'type' => 'number',
					'instructions' => '',
					'required' => 1,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_56f3f6afd33fc',
								'operator' => '==',
								'value' => 'dynamic',
							),
						),
					),
					'wrapper' => array(
						'width' => 50,
						'class' => '',
						'id' => '',
					),
					'default_value' => 1,
					'min' => 1,
					'max' => '',
					'step' => 1,
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'readonly' => 0,
					'disabled' => 0,
				),
				array(
					'key' => 'field_56f3f8277b16e',
					'label' => 'Time type',
					'name' => 'wcra_time_type',
					'type' => 'select',
					'instructions' => '',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_56f3f6afd33fc',
								'operator' => '==',
								'value' => 'dynamic',
							),
						),
					),
					'wrapper' => array(
						'width' => 50,
						'class' => '',
						'id' => '',
					),
					'multiple' => 0,
					'allow_null' => 0,
					'choices' => array(
						'minutes' => 'Minutes',
						'hours' => 'Hours',
						'days' => 'Days',
						'months' => 'Months',
						'years' => 'Years',
					),
					'default_value' => array(
					),
					'ui' => 0,
					'ajax' => 0,
					'placeholder' => '',
					'return_format' => 'value',
					'disabled' => 0,
					'readonly' => 0,
				),
				array(
					'key' => 'field_56e68e5213bb2',
					'label' => 'Dates',
					'name' => 'wcra_dates',
					'type' => 'repeater',
					'instructions' => '<p>Date rules have priority that goes bottom-up. Lower rules have higher priority</p><p>Date rules with starting time greater than "now" are ignored</p>',
					'required' => 1,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_56f3f6afd33fc',
								'operator' => '==',
								'value' => 'fixed',
							),
						),
					),
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'min' => 0,
					'max' => 0,
					'layout' => 'block',
					'button_label' => 'Add time period',
					'collapsed' => '',
					'sub_fields' => array(
						array(
							'key' => 'field_56e68e7313bb3',
							'label' => 'Starting date',
							'name' => 'wcra_starting_date',
							'type' => 'date_picker',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => 50,
								'class' => '',
								'id' => '',
							),
							'display_format' => 'm/d/Y',
							'return_format' => 'Y-m-d',
							'first_day' => 1,
						),
						array(
							'key' => 'field_56e920cfb3e73',
							'label' => 'Start hour',
							'name' => 'wcra_start_hour',
							'type' => 'number',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => 25,
								'class' => '',
								'id' => '',
							),
							'default_value' => 0,
							'min' => 0,
							'max' => 23,
							'step' => 1,
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'readonly' => 0,
							'disabled' => 0,
						),
						array(
							'key' => 'field_56e9211db3e74',
							'label' => 'Start minute',
							'name' => 'wcra_start_minute',
							'type' => 'number',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => 25,
								'class' => '',
								'id' => '',
							),
							'default_value' => 0,
							'min' => 0,
							'max' => 59,
							'step' => 1,
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'readonly' => 0,
							'disabled' => 0,
						),
						array(
							'key' => 'field_56e68f7513bb4',
							'label' => 'Ending date',
							'name' => 'wcra_ending_date',
							'type' => 'date_picker',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => 50,
								'class' => '',
								'id' => '',
							),
							'display_format' => 'm/d/Y',
							'return_format' => 'Y-m-d',
							'first_day' => 1,
						),
						array(
							'key' => 'field_56e92135b3e75',
							'label' => 'End hour',
							'name' => 'wcra_end_hour',
							'type' => 'number',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => 25,
								'class' => '',
								'id' => '',
							),
							'default_value' => 23,
							'min' => 0,
							'max' => 23,
							'step' => 1,
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'readonly' => 0,
							'disabled' => 0,
						),
						array(
							'key' => 'field_56e92149b3e76',
							'label' => 'End minute',
							'name' => 'wcra_end_minute',
							'type' => 'number',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => 25,
								'class' => '',
								'id' => '',
							),
							'default_value' => 59,
							'min' => 0,
							'max' => 59,
							'step' => 1,
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'readonly' => 0,
							'disabled' => 0,
						),
						array(
							'key' => 'field_56f57083ec5b7',
							'label' => 'Would you like to compute role assignment during a different period?',
							'name' => 'wcra_compute_role_assignment_during_different_period',
							'type' => 'select',
							'instructions' => 'By default the role assignment is computed during the configured starting and ending date. You can optionally decide to compute role assignment during a different date.',
							'required' => 1,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'multiple' => 0,
							'allow_null' => 0,
							'choices' => array(
								'no' => 'No',
								'yes' => 'Yes',
							),
							'default_value' => array(
							),
							'ui' => 0,
							'ajax' => 0,
							'placeholder' => '',
							'return_format' => 'value',
							'disabled' => 0,
							'readonly' => 0,
						),
						array(
							'key' => 'field_56f56dc5ec5b0',
							'label' => 'Effective assignment starting date',
							'name' => 'wcra_effective_starting_date',
							'type' => 'date_picker',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => array(
								array(
									array(
										'field' => 'field_56f3f6afd33fc',
										'operator' => '==',
										'value' => 'fixed',
									),
									array(
										'field' => 'field_56f57083ec5b7',
										'operator' => '==',
										'value' => 'yes',
									),
								),
							),
							'wrapper' => array(
								'width' => 50,
								'class' => '',
								'id' => '',
							),
							'display_format' => 'm/d/Y',
							'return_format' => 'Y-m-d',
							'first_day' => 1,
						),
						array(
							'key' => 'field_56f5701cec5b4',
							'label' => 'Effective assignment start hour',
							'name' => 'wcra_effective_start_hour',
							'type' => 'number',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => array(
								array(
									array(
										'field' => 'field_56f3f6afd33fc',
										'operator' => '==',
										'value' => 'fixed',
									),
									array(
										'field' => 'field_56f57083ec5b7',
										'operator' => '==',
										'value' => 'yes',
									),
								),
							),
							'wrapper' => array(
								'width' => 25,
								'class' => '',
								'id' => '',
							),
							'default_value' => 0,
							'min' => 0,
							'max' => 59,
							'step' => 1,
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'readonly' => 0,
							'disabled' => 0,
						),
						array(
							'key' => 'field_56f57021ec5b5',
							'label' => 'Effective assignment	start minute',
							'name' => 'wcra_effective_start_minute',
							'type' => 'number',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => array(
								array(
									array(
										'field' => 'field_56f3f6afd33fc',
										'operator' => '==',
										'value' => 'fixed',
									),
									array(
										'field' => 'field_56f57083ec5b7',
										'operator' => '==',
										'value' => 'yes',
									),
								),
							),
							'wrapper' => array(
								'width' => 25,
								'class' => '',
								'id' => '',
							),
							'default_value' => 59,
							'min' => 0,
							'max' => 59,
							'step' => 1,
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'readonly' => 0,
							'disabled' => 0,
						),
						array(
							'key' => 'field_56f56fe7ec5b1',
							'label' => 'Effective assignment ending date',
							'name' => 'wcra_effective_ending_date',
							'type' => 'date_picker',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => array(
								array(
									array(
										'field' => 'field_56f3f6afd33fc',
										'operator' => '==',
										'value' => 'fixed',
									),
									array(
										'field' => 'field_56f57083ec5b7',
										'operator' => '==',
										'value' => 'yes',
									),
								),
							),
							'wrapper' => array(
								'width' => 50,
								'class' => '',
								'id' => '',
							),
							'display_format' => 'm/d/Y',
							'return_format' => 'Y-m-d',
							'first_day' => 1,
						),
						array(
							'key' => 'field_56f57001ec5b2',
							'label' => 'Effective assignment	end hour',
							'name' => 'wcra_effective_end_hour',
							'type' => 'number',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => array(
								array(
									array(
										'field' => 'field_56f3f6afd33fc',
										'operator' => '==',
										'value' => 'fixed',
									),
									array(
										'field' => 'field_56f57083ec5b7',
										'operator' => '==',
										'value' => 'yes',
									),
								),
							),
							'wrapper' => array(
								'width' => 25,
								'class' => '',
								'id' => '',
							),
							'default_value' => 23,
							'min' => 0,
							'max' => 23,
							'step' => 1,
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'readonly' => 0,
							'disabled' => 0,
						),
						array(
							'key' => 'field_56f57017ec5b3',
							'label' => 'Effective assignment	end minute',
							'name' => 'wcra_effective_end_minute',
							'type' => 'number',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => array(
								array(
									array(
										'field' => 'field_56f3f6afd33fc',
										'operator' => '==',
										'value' => 'fixed',
									),
									array(
										'field' => 'field_56f57083ec5b7',
										'operator' => '==',
										'value' => 'yes',
									),
								),
							),
							'wrapper' => array(
								'width' => 25,
								'class' => '',
								'id' => '',
							),
							'default_value' => 59,
							'min' => 0,
							'max' => 59,
							'step' => 1,
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'readonly' => 0,
							'disabled' => 0,
						),
					),
				),
				array(
					'key' => 'field_58932e2c81d42',
					'label' => 'Email notification',
					'name' => 'wcra_email_notification',
					'type' => 'select',
					'instructions' => 'Optionally you can send an email to the user to allowing him to now about the role change.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'choices' => array(
						'no' => 'No',
						'yes' => 'Yes',
					),
					'default_value' => array(
					),
					'allow_null' => 0,
					'multiple' => 0,
					'ui' => 0,
					'ajax' => 0,
					'return_format' => 'value',
					'placeholder' => '',
				),
				array(
					'key' => 'field_589eff6a27314',
					'label' => 'Email subject',
					'name' => 'wcra_notification_email_subject',
					'type' => 'text',
					'instructions' => 'Subject of the notification email that will sent to the user once the role(s) has been assigned.',
					'required' => 1,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_58932e2c81d42',
								'operator' => '==',
								'value' => 'yes',
							),
						),
					),
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'default_value' => 'Congratulation!',
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'maxlength' => '',
				),
				array(
					'key' => 'field_58932e7681d43',
					'label' => 'Email text',
					'name' => 'wcra_notification_email_text',
					'type' => 'wysiwyg',
					'instructions' => 'Text of the notification email that will sent to the user once the role(s) has been assigned.',
					'required' => 1,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_58932e2c81d42',
								'operator' => '==',
								'value' => 'yes',
							),
						),
					),
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'default_value' => '',
					'tabs' => 'all',
					'toolbar' => 'basic',
					'media_upload' => 0,
					'delay' => 0,
				),
				array(
					'key' => 'field_56e69069d3867',
					'label' => 'Role(s) restriction',
					'name' => 'wcra_role_restriction',
					'type' => 'role_selector',
					'instructions' => 'You can restrict role assignment selecting to which user role(s) the rules can be applied. Only Customers belonging to that role(s) can be assigned the new role according to the amount spent. Leave unselected to have no restriction.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'return_value' => 'name',
					'field_type' => 'checkbox',
					'allowed_roles' => '',
				),
				array(
					'key' => 'field_56ebb39227a9c',
					'label' => 'Product(s) restriction',
					'name' => 'wcra_products_restriction',
					'type' => 'post_object',
					'instructions' => 'Rule can be applied only to amount spent to buy the selected item(s).',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => 50,
						'class' => '',
						'id' => '',
					),
					'post_type' => array(
						0 => 'product',
						1 => 'product_variation',
					),
					'taxonomy' => array(
					),
					'allow_null' => 0,
					'multiple' => 1,
					'return_format' => 'id',
					'ui' => 1,
				),
				array(
					'key' => 'field_56ebb3e827a9d',
					'label' => 'Category(ies) restriction',
					'name' => 'wcra_categories_restriction',
					'type' => 'taxonomy',
					'instructions' => 'Rule can be applied only to amount spent on item beloging to the selected category(ies).',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => 50,
						'class' => '',
						'id' => '',
					),
					'taxonomy' => 'product_cat',
					'field_type' => 'multi_select',
					'multiple' => 0,
					'allow_null' => 1,
					'return_format' => 'id',
					'add_term' => 0,
					'load_terms' => 0,
					'save_terms' => 0,
				),
				array(
					'key' => 'field_56f567b9e8c32',
					'label' => 'Assignment strategy',
					'name' => 'wcra_selected_strategy',
					'type' => 'radio',
					'instructions' => 'You can assign a scheduling rule to selected item(s)/category(ies) or to all excluding the selected ones.',
					'required' => 1,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => 50,
						'class' => '',
						'id' => '',
					),
					'layout' => 'vertical',
					'choices' => array(
						'all' => 'For all selected item(s)',
						'except' => 'Except the selected item(s)/category(ies)',
					),
					'default_value' => 'all',
					'other_choice' => 0,
					'save_other_choice' => 0,
					'allow_null' => 0,
					'return_format' => 'value',
				),
				array(
					'key' => 'field_56f567c4e8c33',
					'label' => 'Children categories',
					'name' => 'wcra_categories_children',
					'type' => 'radio',
					'instructions' => 'If at least one category has been selected, you can decide to apply the scheduling rule also to children categories items',
					'required' => 1,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => 50,
						'class' => '',
						'id' => '',
					),
					'layout' => 'vertical',
					'choices' => array(
						'selected_only' => 'Apply to selected categories only',
						'all_children' => 'Apply to selected categories and all its children',
					),
					'default_value' => 'selected_only',
					'other_choice' => 0,
					'save_other_choice' => 0,
					'allow_null' => 0,
					'return_format' => 'value',
				),
				array(
					'key' => 'field_56e6955051a4b',
					'label' => 'Minimum amount',
					'name' => 'wcra_amount',
					'type' => 'number',
					'instructions' => 'Minimum amout <strong>excluding taxes</strong> spent during the period(s) . If the customer has spent more that this value he will be assigned the selected role(s).',
					'required' => 1,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '50',
						'class' => '',
						'id' => '',
					),
					'default_value' => 1,
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'min' => '0.1',
					'max' => '',
					'step' => '0.01',
				),
				array(
					'key' => 'field_56e93a0091b74',
					'label' => 'Max amount',
					'name' => 'wcra_max_amount',
					'type' => 'number',
					'instructions' => 'Total maximum amout <strong>excluding taxes</strong> spent during the period(s) . Can be left empty or 0 to have no limit.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '50',
						'class' => '',
						'id' => '',
					),
					'default_value' => '',
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'min' => 0,
					'max' => '',
					'step' => '0.01',
				),
				array(
					'key' => 'field_56e694f951a4a',
					'label' => 'Role(s) to assign',
					'name' => 'wcra_roles_to_assign',
					'type' => 'role_selector',
					'instructions' => 'Select which role(s) assign to the customer who have spent the amount during the periods',
					'required' => 1,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '50',
						'class' => '',
						'id' => '',
					),
					'return_value' => 'name',
					'field_type' => 'checkbox',
					'allowed_roles' => '',
				),
				array(
					'key' => 'field_57fd1853544ed',
					'label' => 'Remove old role(s) before assign the new one(s)',
					'name' => 'wcra_remove_old_roles_before_assign_the_new_ones',
					'type' => 'select',
					'instructions' => 'Selecting <strong>Yes</strong> all the current user roles will be removed and then assigned the selected ones.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '50',
						'class' => '',
						'id' => '',
					),
					'choices' => array(
						'no' => 'No',
						'yes' => 'Yes',
						'selected_ones' => 'Selected ones',
					),
					'default_value' => array(
					),
					'allow_null' => 0,
					'multiple' => 0,
					'ui' => 0,
					'ajax' => 0,
					'return_format' => 'value',
					'placeholder' => '',
				),
				array(
					'key' => 'field_592976b24dfba',
					'label' => 'Which roles have to be removed',
					'name' => 'wcra_which_roles_have_to_be_removed',
					'type' => 'role_selector',
					'instructions' => '',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_57fd1853544ed',
								'operator' => '==',
								'value' => 'selected_ones',
							),
						),
					),
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'return_value' => 'name',
					'allowed_roles' => '',
					'field_type' => 'checkbox',
				),
				array(
					'key' => 'field_56ec48aa11157',
					'label' => 'Role(s) removal if amount spent doesn\'t match',
					'name' => 'wcra_roles_removal',
					'type' => 'select',
					'instructions' => '<p>If the user has already associated one (or more) role assigned by the rule, it will be removed if the amount spent during the configured periods doesn\'t match the rule. Select <strong>No</strong> to leave his roles unchanged though the rule doesn\'t match. </p><p>Select the <strong>Selected ones</strong> option to remove specific roles.</p>
<p>In case after removing the selected roles the user will have no roles assigned, the plugin will assign the base <strong>Customer</strong> role.</p>
<p>&nbsp;</p><p>
<strong>IMPORTANT NOTE:</strong> Roles are computed after an order placement or an order status update. If none of this events happen, role(s) are NOT recomputed and then they are NOT eventually removed. To force role reassignment use the Role re-calculator tool.</p>',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'choices' => array(
						'no' => 'No',
						'yes' => 'Yes',
						'selected_ones' => 'Selected ones',
					),
					'default_value' => array(
					),
					'allow_null' => 0,
					'multiple' => 0,
					'ui' => 0,
					'ajax' => 0,
					'return_format' => 'value',
					'placeholder' => '',
				),
				array(
					'key' => 'field_5929757162272',
					'label' => 'Which roles have to be removed',
					'name' => 'wcra_which_roles_have_to_be_removed_after_expiration',
					'type' => 'role_selector',
					'instructions' => '',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_56ec48aa11157',
								'operator' => '==',
								'value' => 'selected_ones',
							),
						),
					),
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'return_value' => 'name',
					'allowed_roles' => '',
					'field_type' => 'checkbox',
				),
			),
		),
	),
	'location' => array(
		array(
			array(
				'param' => 'options_page',
				'operator' => '==',
				'value' => 'acf-options-amounts-configurator',
			),
		),
	),
	'menu_order' => 0,
	'position' => 'normal',
	'style' => 'default',
	'label_placement' => 'top',
	'instruction_placement' => 'label',
	'hide_on_screen' => '',
	'active' => true,
	'description' => '',
	'show_in_rest' => false,
));

acf_add_local_field_group(array(
	'key' => 'group_5742b336bf416',
	'title' => 'WooCommerce Role Assigner - General Options',
	'fields' => array(
		array(
			'key' => 'field_5708d9592f180',
			'label' => 'Automatic role recomputation',
			'name' => 'wcra_automatic_role_recomputation',
			'type' => 'select',
			'instructions' => 'Role(s) assignement check by default it\'s only performed after an order has been placed, after it has been edited/saved or its status has been changed in the admin area. However You can automatize this operation by choosing a time interval span after which check is regularly performed.',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'multiple' => 0,
			'allow_null' => 0,
			'choices' => array(
				'no' => 'No',
				'yes' => 'Yes',
			),
			'default_value' => array(
			),
			'ui' => 0,
			'ajax' => 0,
			'placeholder' => '',
			'return_format' => 'value',
			'disabled' => 0,
			'readonly' => 0,
		),
		array(
			'key' => 'field_5708db392f181',
			'label' => 'Recomputation frequency - quantity',
			'name' => 'wcra_time_quantity',
			'type' => 'number',
			'instructions' => 'Define the time span after which the roles are recoputed. For example: <i>Every 2 hours</i>,<i>Every 30 Days</i>, etc.',
			'required' => 0,
			'conditional_logic' => array(
				array(
					array(
						'field' => 'field_5708d9592f180',
						'operator' => '==',
						'value' => 'yes',
					),
				),
			),
			'wrapper' => array(
				'width' => '20',
				'class' => '',
				'id' => '',
			),
			'default_value' => 1,
			'min' => 1,
			'max' => '',
			'step' => 1,
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
		),
		array(
			'key' => 'field_5708dc1d2f182',
			'label' => 'Recomputation frequency - type',
			'name' => 'wcra_time_span',
			'type' => 'select',
			'instructions' => 'Define the frequency <i>type</i>.',
			'required' => 0,
			'conditional_logic' => array(
				array(
					array(
						'field' => 'field_5708d9592f180',
						'operator' => '==',
						'value' => 'yes',
					),
				),
			),
			'wrapper' => array(
				'width' => '20',
				'class' => '',
				'id' => '',
			),
			'multiple' => 0,
			'allow_null' => 0,
			'choices' => array(
				'hour' => 'hour(s)',
				'day' => 'day(s)',
			),
			'default_value' => array(
			),
			'ui' => 0,
			'ajax' => 0,
			'placeholder' => '',
			'return_format' => 'value',
		),
		array(
			'key' => 'field_5708ff5bc3118',
			'label' => 'Starting from - hour',
			'name' => 'wcra_start_hour',
			'type' => 'number',
			'instructions' => 'Once the options are saved, the automatic role recoputation will start at the time specified in the following fields. For example if you set <i>22:00</i>, the recoputation will start its first run today at 22:00 and it will continue according to the frequency settings.',
			'required' => 1,
			'conditional_logic' => array(
				array(
					array(
						'field' => 'field_5708d9592f180',
						'operator' => '==',
						'value' => 'yes',
					),
				),
			),
			'wrapper' => array(
				'width' => '30',
				'class' => '',
				'id' => '',
			),
			'default_value' => 0,
			'min' => 0,
			'max' => 23,
			'step' => 1,
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
		),
		array(
			'key' => 'field_57090162c3119',
			'label' => 'Starting from - minute',
			'name' => 'wcra_start_minute',
			'type' => 'number',
			'instructions' => '<p>Define the starting minute.</p>',
			'required' => 1,
			'conditional_logic' => array(
				array(
					array(
						'field' => 'field_5708d9592f180',
						'operator' => '==',
						'value' => 'yes',
					),
				),
			),
			'wrapper' => array(
				'width' => '30',
				'class' => '',
				'id' => '',
			),
			'default_value' => 1,
			'min' => 0,
			'max' => 59,
			'step' => 1,
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
		),
		array(
			'key' => 'field_57459868e9da7',
			'label' => 'Exclude orders by status',
			'name' => 'wcra_exclude_orders_by_status',
			'type' => 'select',
			'instructions' => 'The plugin will consider only orders with the selected statuses to compute roles by amount spent or by product.',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'multiple' => 0,
			'allow_null' => 0,
			'choices' => array(
				'yes' => 'Yes',
				'no' => 'No',
			),
			'default_value' => array(
			),
			'ui' => 0,
			'ajax' => 0,
			'placeholder' => '',
			'return_format' => 'value',
			'disabled' => 0,
			'readonly' => 0,
		),
		array(
			'key' => 'field_5745940db434f',
			'label' => 'Order status to exclude',
			'name' => 'wcra_order_status_to_exclude',
			'type' => 'checkbox',
			'instructions' => 'Select which statuses exclude from computation',
			'required' => 1,
			'conditional_logic' => array(
				array(
					array(
						'field' => 'field_57459868e9da7',
						'operator' => '==',
						'value' => 'yes',
					),
				),
			),
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'layout' => 'horizontal',
			'choices' => array(
				'failed' => 'Failed',
				'refunded' => 'Refunded',
				'cancelled' => 'Cancelled',
				'pending' => 'Pending Payment',
				'on-hold' => 'On Hold',
				'processing' => 'Processing',
				'completed' => 'Completed',
			),
			'default_value' => array(
				0 => 'failed',
				1 => 'refunded',
				2 => 'cancelled',
				3 => 'pending',
			),
			'allow_custom' => 0,
			'save_custom' => 0,
			'toggle' => 0,
			'return_format' => 'value',
		),
		array(
			'key' => 'field_57ee597a034aa',
			'label' => 'My account page - Display current assigned roles list',
			'name' => 'wcra_my_account_page_display_current_roles_list',
			'type' => 'select',
			'instructions' => '',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '50',
				'class' => '',
				'id' => '',
			),
			'multiple' => 0,
			'allow_null' => 0,
			'choices' => array(
				'yes' => 'Yes',
				'no' => 'No',
			),
			'default_value' => array(
			),
			'ui' => 0,
			'ajax' => 0,
			'placeholder' => '',
			'return_format' => 'value',
		),
		array(
			'key' => 'field_57ee59bc034ab',
			'label' => 'My account page - Roles to exclude from role list',
			'name' => 'wcra_my_account_page_roles_to_exclude_from_role_list',
			'type' => 'role_selector',
			'instructions' => 'Select which roles have not to be displayed in roles list even if they have been asigned to the user.',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '50',
				'class' => '',
				'id' => '',
			),
			'return_value' => 'name',
			'field_type' => 'checkbox',
			'allowed_roles' => '',
		),
		array(
			'key' => 'field_57ee5a0b034ac',
			'label' => 'My account page - Display next roles list',
			'name' => 'wcra_my_account_page_display_next_roles_list',
			'type' => 'select',
			'instructions' => 'By default in the My Account page, in the Dashboard tab, the plugin displays a list containing all the assignables roles during the current period, how much the user spent to reach them and how much it misses. Select <strong>No</strong> to disable this feature.',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'multiple' => 0,
			'allow_null' => 0,
			'choices' => array(
				'yes' => 'Yes',
				'no' => 'No',
			),
			'default_value' => array(
			),
			'ui' => 0,
			'ajax' => 0,
			'placeholder' => '',
			'return_format' => 'value',
		),
	),
	'location' => array(
		array(
			array(
				'param' => 'options_page',
				'operator' => '==',
				'value' => 'acf-options-general-options',
			),
		),
	),
	'menu_order' => 0,
	'position' => 'normal',
	'style' => 'default',
	'label_placement' => 'top',
	'instruction_placement' => 'label',
	'hide_on_screen' => '',
	'active' => true,
	'description' => '',
	'show_in_rest' => false,
));

acf_add_local_field_group(array(
	'key' => 'group_5742ac6984186',
	'title' => 'WooCommerce Role Assigner - Products configurator',
	'fields' => array(
		array(
			'key' => 'field_5742aee40aa6f',
			'label' => 'Role per Purchased Products rules',
			'name' => 'wcra_products_rules',
			'type' => 'repeater',
			'instructions' => '<p>Here you can configure which roles have to be assigned according to the purchased products. </p>
<p><strong>NOTE:</strong> Rules are applied top-bottom, so lower rules have higher priority (in case you define more rules for the user role).',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'collapsed' => 'field_5742af880aa70',
			'min' => 0,
			'max' => 0,
			'layout' => 'block',
			'button_label' => 'Add new rule',
			'sub_fields' => array(
				array(
					'key' => 'field_5c77b6fb68297',
					'label' => 'Rule application policy',
					'name' => 'wcra_skip_rule_application',
					'type' => 'true_false',
					'instructions' => 'Skip this rule application if any previous rule has been already applied.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'message' => '',
					'default_value' => 0,
					'ui' => 1,
					'ui_on_text' => '',
					'ui_off_text' => '',
				),
				array(
					'key' => 'field_5742af880aa70',
					'label' => 'Roles to assign',
					'name' => 'wcra_product_roles_to_assign',
					'type' => 'role_selector',
					'instructions' => 'Select which role(s) to assign',
					'required' => 1,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '33',
						'class' => '',
						'id' => '',
					),
					'return_value' => 'name',
					'allowed_roles' => '',
					'field_type' => 'checkbox',
				),
				array(
					'key' => 'field_58199cdde3965',
					'label' => 'Remove old role(s) before assign the new one(s)',
					'name' => 'wcra_product_remove_old_roles_before_assign_the_new_ones',
					'type' => 'select',
					'instructions' => 'Selecting <strong>Yes</strong> all the current user roles will be removed and then assigned the selected ones.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '33',
						'class' => '',
						'id' => '',
					),
					'choices' => array(
						'no' => 'No',
						'yes' => 'Yes',
						'selected_ones' => 'Selected ones',
					),
					'default_value' => array(
					),
					'allow_null' => 0,
					'multiple' => 0,
					'ui' => 0,
					'return_format' => 'value',
					'ajax' => 0,
					'placeholder' => '',
				),
				array(
					'key' => 'field_5c78eae6d8b68',
					'label' => 'Role(s) restriction',
					'name' => 'wcra_product_roles_restriction',
					'type' => 'role_selector',
					'instructions' => 'You can restrict role assignment selecting to which user role(s) the rules can be applied. Only Customers belonging to that role(s) can be assigned the new role according to the amount spent. Leave unselected to have no restriction.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '34',
						'class' => '',
						'id' => '',
					),
					'return_value' => 'name',
					'allowed_roles' => '',
					'field_type' => 'checkbox',
				),
				array(
					'key' => 'field_5929754e62271',
					'label' => 'Which roles have to be removed',
					'name' => 'wcra_product_which_roles_have_to_be_removed',
					'type' => 'role_selector',
					'instructions' => '',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_58199cdde3965',
								'operator' => '==',
								'value' => 'selected_ones',
							),
						),
					),
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'return_value' => 'name',
					'allowed_roles' => '',
					'field_type' => 'checkbox',
				),
				array(
					'key' => 'field_5742bdbb697ac',
					'label' => 'Select products',
					'name' => 'wcr_selected_products',
					'type' => 'post_object',
					'instructions' => 'If at least one of the selected product is pruchased, the selected roles will be assigned.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '50',
						'class' => '',
						'id' => '',
					),
					'post_type' => array(
						0 => 'product',
						1 => 'product_variation',
					),
					'taxonomy' => '',
					'allow_null' => 0,
					'multiple' => 1,
					'return_format' => 'id',
					'ui' => 1,
				),
				array(
					'key' => 'field_5a98414cf743e',
					'label' => 'Select categories',
					'name' => 'wcra_selected_categories',
					'type' => 'taxonomy',
					'instructions' => 'If at least one of the purchased products belongs to one of the selected categories, the selected roles will be assigned.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '50',
						'class' => '',
						'id' => '',
					),
					'taxonomy' => 'product_cat',
					'field_type' => 'multi_select',
					'allow_null' => 0,
					'add_term' => 0,
					'save_terms' => 0,
					'load_terms' => 0,
					'return_format' => 'id',
					'multiple' => 0,
				),
				array(
					'key' => 'field_5c77a3cad4d44',
					'label' => 'Products/Category purchase policy',
					'name' => 'wcra_products_relation',
					'type' => 'select',
					'instructions' => '<ol>
<li><strong>OR:</strong> roles will be assigned if at least one of the selected products has been purchased</li>
<li><strong>AND:</strong> one of each the selected products has to be purchased. In case of categories selection, there must be in the order one <strong>distinct</strong> product for each selected category.</li>
</ol>',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '34',
						'class' => '',
						'id' => '',
					),
					'choices' => array(
						'or' => 'OR',
						'and' => 'AND',
					),
					'default_value' => array(
					),
					'allow_null' => 0,
					'multiple' => 0,
					'ui' => 0,
					'return_format' => 'value',
					'ajax' => 0,
					'placeholder' => '',
				),
				array(
					'key' => 'field_5c73ad51d38cb',
					'label' => 'Quantity policy',
					'name' => 'wcra_quantity_policy',
					'type' => 'select',
					'instructions' => '<ol>
<li><strong>Ignore:</strong> product quantities will be ignored</li>
<li><strong>Number of distinct products:</strong> selected roles will be associated only if the user purchases at least N distinct items of the selected products. The value of <i>N</i> can be set through the <strong>Quantity value</strong> option</li>
</ol>',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5c77a3cad4d44',
								'operator' => '==',
								'value' => 'or',
							),
						),
					),
					'wrapper' => array(
						'width' => '33',
						'class' => '',
						'id' => '',
					),
					'choices' => array(
						'ignore' => 'Ignore',
						'number_of_distinct_product' => 'Number of distinct products',
					),
					'default_value' => array(
					),
					'allow_null' => 0,
					'multiple' => 0,
					'ui' => 0,
					'return_format' => 'value',
					'ajax' => 0,
					'placeholder' => '',
				),
				array(
					'key' => 'field_5c73af96d38cc',
					'label' => 'Quantity value',
					'name' => 'wcra_quantity_value',
					'type' => 'number',
					'instructions' => 'Select the number of distinct products',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5c77a3cad4d44',
								'operator' => '==',
								'value' => 'or',
							),
							array(
								'field' => 'field_5c73ad51d38cb',
								'operator' => '!=',
								'value' => 'ignore',
							),
						),
					),
					'wrapper' => array(
						'width' => '33',
						'class' => '',
						'id' => '',
					),
					'default_value' => '',
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'min' => 1,
					'max' => '',
					'step' => 1,
				),
				array(
					'key' => 'field_5c78ebfed8b69',
					'label' => 'Email notification',
					'name' => 'wcra_product_roles_email_notification',
					'type' => 'true_false',
					'instructions' => 'Optionally you can send an email to the user to allowing him to now about the role change.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'message' => '',
					'default_value' => 0,
					'ui' => 1,
					'ui_on_text' => '',
					'ui_off_text' => '',
				),
				array(
					'key' => 'field_5c78ec3bd8b6a',
					'label' => 'Subject',
					'name' => 'wcra_product_roles_notification_email_subject',
					'type' => 'text',
					'instructions' => '',
					'required' => 1,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5c78ebfed8b69',
								'operator' => '==',
								'value' => '1',
							),
						),
					),
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'default_value' => '',
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'maxlength' => '',
				),
				array(
					'key' => 'field_5c78ec78d8b6b',
					'label' => 'Email text',
					'name' => 'wcra_product_roles_notification_email_text',
					'type' => 'wysiwyg',
					'instructions' => 'You can use the [removed_roles] and [added_roles] shortocodes to list the names of the removed and added roles.',
					'required' => 1,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5c78ebfed8b69',
								'operator' => '==',
								'value' => '1',
							),
						),
					),
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'default_value' => '',
					'tabs' => 'all',
					'toolbar' => 'basic',
					'media_upload' => 0,
					'delay' => 0,
				),
				array(
					'key' => 'field_5742be63697ad',
					'label' => 'Expiring date type',
					'name' => 'wcra_expiring_date_type',
					'type' => 'select',
					'instructions' => '<p>Expiring date can be <strong>Fixed</strong>: in this case the user role will be removed after that date; or <strong>Relative</strong>: in this case the user role will be removed after the selected time span from the item purchased time.</p>
<p>&nbsp;</p>
<p><strong>NOTE:</strong> After expiring date, roles will be removed and added according to this rule. This mean that if you manually change roles of an user who puchesed the selected items, they will be resetted according this rule after he accesses the site.</p>',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'choices' => array(
						'none' => 'None',
						'fixed' => 'Fixed',
						'relative' => 'Relative',
					),
					'default_value' => array(
					),
					'allow_null' => 0,
					'multiple' => 0,
					'ui' => 0,
					'return_format' => 'value',
					'ajax' => 0,
					'placeholder' => '',
				),
				array(
					'key' => 'field_5742be8c697ae',
					'label' => 'Expiring date',
					'name' => 'wcra_expiring_fixed_date',
					'type' => 'date_picker',
					'instructions' => '',
					'required' => 1,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5742be63697ad',
								'operator' => '==',
								'value' => 'fixed',
							),
						),
					),
					'wrapper' => array(
						'width' => 60,
						'class' => '',
						'id' => '',
					),
					'display_format' => 'm/d/Y',
					'return_format' => 'Y-m-d',
					'first_day' => 1,
				),
				array(
					'key' => 'field_5743303fa9ac7',
					'label' => 'Expiring hour',
					'name' => 'wcra_expiring_hour',
					'type' => 'number',
					'instructions' => '',
					'required' => 1,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5742be63697ad',
								'operator' => '==',
								'value' => 'fixed',
							),
						),
					),
					'wrapper' => array(
						'width' => 20,
						'class' => '',
						'id' => '',
					),
					'default_value' => 23,
					'min' => 0,
					'max' => 23,
					'step' => 1,
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'readonly' => 0,
					'disabled' => 0,
				),
				array(
					'key' => 'field_5743306ba9ac8',
					'label' => 'Expiring minute',
					'name' => 'wcra_expiring_minute',
					'type' => 'number',
					'instructions' => '',
					'required' => 1,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5742be63697ad',
								'operator' => '==',
								'value' => 'fixed',
							),
						),
					),
					'wrapper' => array(
						'width' => 20,
						'class' => '',
						'id' => '',
					),
					'default_value' => 59,
					'min' => 0,
					'max' => 59,
					'step' => 1,
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'readonly' => 0,
					'disabled' => 0,
				),
				array(
					'key' => 'field_5742bef8697af',
					'label' => 'Time value',
					'name' => 'wcra_expiring_date_value',
					'type' => 'number',
					'instructions' => '',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5742be63697ad',
								'operator' => '==',
								'value' => 'relative',
							),
						),
					),
					'wrapper' => array(
						'width' => 50,
						'class' => '',
						'id' => '',
					),
					'default_value' => 1,
					'min' => 1,
					'max' => '',
					'step' => 1,
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'readonly' => 0,
					'disabled' => 0,
				),
				array(
					'key' => 'field_5742bf1f697b0',
					'label' => 'Time type',
					'name' => 'wcra_expiring_time_type',
					'type' => 'select',
					'instructions' => '',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5742be63697ad',
								'operator' => '==',
								'value' => 'relative',
							),
						),
					),
					'wrapper' => array(
						'width' => 50,
						'class' => '',
						'id' => '',
					),
					'multiple' => 0,
					'allow_null' => 0,
					'choices' => array(
						'minutes' => 'Minute(s)',
						'hours' => 'Hour(s)',
						'days' => 'Day(s)',
						'months' => 'Month(s)',
					),
					'default_value' => array(
						0 => 'minutes',
					),
					'ui' => 0,
					'ajax' => 0,
					'placeholder' => '',
					'return_format' => 'value',
					'disabled' => 0,
					'readonly' => 0,
				),
				array(
					'key' => 'field_5822f29ec67bb',
					'label' => 'Role(s) to assign after expiring date',
					'name' => 'wcra_roles_to_assign_after_expiring_date',
					'type' => 'role_selector',
					'instructions' => 'It at least one is selected, it will be assigned <strong>in addition</strong> to the role(s) the customer already has.',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5742be63697ad',
								'operator' => '!=',
								'value' => 'none',
							),
						),
					),
					'wrapper' => array(
						'width' => '50',
						'class' => '',
						'id' => '',
					),
					'return_value' => 'name',
					'field_type' => 'checkbox',
					'allowed_roles' => '',
				),
				array(
					'key' => 'field_5823042e4d523',
					'label' => 'Remove all roles before assign expring date role(s)',
					'name' => 'wcra_remove_all_roles_before_assign_expring_date_roles',
					'type' => 'select',
					'instructions' => 'If you have selected to assign at least one role after expiring date, setting this option to <strong>Yes</strong> will remove all previous roles befor assigning the new one.',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5742be63697ad',
								'operator' => '!=',
								'value' => 'none',
							),
						),
					),
					'wrapper' => array(
						'width' => '50',
						'class' => '',
						'id' => '',
					),
					'choices' => array(
						'no' => 'No',
						'yes' => 'Yes',
						'selected_ones' => 'Selected ones',
					),
					'default_value' => array(
					),
					'allow_null' => 0,
					'multiple' => 0,
					'ui' => 0,
					'ajax' => 0,
					'return_format' => 'value',
					'placeholder' => '',
				),
				array(
					'key' => 'field_592984fe3f0a2',
					'label' => 'Which roles have to be removed',
					'name' => 'wcra_product_which_roles_have_to_be_removed_before_assign_expiring_date',
					'type' => 'role_selector',
					'instructions' => '',
					'required' => 0,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5742be63697ad',
								'operator' => '!=',
								'value' => 'none',
							),
							array(
								'field' => 'field_5823042e4d523',
								'operator' => '==',
								'value' => 'selected_ones',
							),
						),
					),
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'return_value' => 'name',
					'allowed_roles' => '',
					'field_type' => 'checkbox',
				),
				array(
					'key' => 'field_5742cf2f15c8b',
					'label' => 'Can customers repurchase before expiring date?',
					'name' => 'wcra_repurchase_strategy',
					'type' => 'select',
					'instructions' => '<p>If <strong>Yes</strong> is selected, the item(s) expiring date will be extended.</p>
<p>For example, if the relative date has been setted to 3 months and the customer repurchases the item(s), the expiring date will be extended by 3 months</p>',
					'required' => 1,
					'conditional_logic' => array(
						array(
							array(
								'field' => 'field_5742be63697ad',
								'operator' => '==',
								'value' => 'relative',
							),
						),
					),
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'multiple' => 0,
					'allow_null' => 0,
					'choices' => array(
						'yes' => 'Yes',
						'no' => 'No',
					),
					'default_value' => array(
					),
					'ui' => 0,
					'ajax' => 0,
					'placeholder' => '',
					'return_format' => 'value',
					'disabled' => 0,
					'readonly' => 0,
				),
				array(
					'key' => 'field_5742cfdc15c8c',
					'label' => 'Products puchase resriction',
					'name' => 'wcra_purchase_restriction_by_products',
					'type' => 'post_object',
					'instructions' => '<p>If the roles selected in the <strong>Roles to assign</strong> field are still associated to the customer you can optionally deny the purchasing of the following product(s):</p>
<p><strong>NOTE: </strong>Leave empty to have no restriction.</p>',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array(
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'post_type' => array(
						0 => 'product',
						1 => 'product_variation',
					),
					'taxonomy' => array(
					),
					'allow_null' => 0,
					'multiple' => 1,
					'return_format' => 'id',
					'ui' => 1,
				),
			),
		),
	),
	'location' => array(
		array(
			array(
				'param' => 'options_page',
				'operator' => '==',
				'value' => 'acf-options-products-configurator',
			),
		),
	),
	'menu_order' => 0,
	'position' => 'normal',
	'style' => 'default',
	'label_placement' => 'top',
	'instruction_placement' => 'label',
	'hide_on_screen' => '',
	'active' => true,
	'description' => '',
	'show_in_rest' => 0,
));

acf_add_local_field_group(array(
	'key' => 'group_57ee4757d6090',
	'title' => 'WooCommerce Role Assigner - Texts',
	'fields' => array(
		array(
			'key' => 'field_57ee5b248d064',
			'label' => 'Role list title',
			'name' => 'wcra_role_list_title',
			'type' => 'text',
			'instructions' => '<strong>WPML</strong> users can customize title according to language, just switch language using the wpml language selector and enter the text.',
			'required' => 1,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '50',
				'class' => '',
				'id' => '',
			),
			'default_value' => 'Role list',
			'maxlength' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
		),
		array(
			'key' => 'field_57ee5b468d065',
			'label' => 'Next roles list title',
			'name' => 'wcra_next_roles_list_title',
			'type' => 'text',
			'instructions' => '<strong>WPML</strong> users can customize title according to language, just switch language using the wpml language selector and enter the text.',
			'required' => 1,
			'conditional_logic' => 0,
			'wrapper' => array(
				'width' => '50',
				'class' => '',
				'id' => '',
			),
			'default_value' => 'Next roles',
			'maxlength' => '',
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
		),
	),
	'location' => array(
		array(
			array(
				'param' => 'options_page',
				'operator' => '==',
				'value' => 'acf-options-role-o-matic-texts',
			),
		),
	),
	'menu_order' => 0,
	'position' => 'normal',
	'style' => 'default',
	'label_placement' => 'top',
	'instruction_placement' => 'label',
	'hide_on_screen' => '',
	'active' => true,
	'description' => '',
	'show_in_rest' => false,
));

endif;		
?>