jQuery(document).ready(function()
{
	jQuery("#customer_ids").select2(
	{
	  ajax: {
		url: ajaxurl,
		dataType: 'json',
		delay: 250,
		multiple: true,
		width: 'resolve',
		data: function (params) {
		  return {
			customer: params.term, // search term
			page: params.page,
			action: 'wcra_get_customers_list'
		  };
		},
		processResults: function (data, page) 
		{
	   
		   return {
			results: jQuery.map(data, function(obj) 
			{
				return { id: obj.customer_id, text: "<strong>"+obj.username+":</strong> "+obj.first_name+" "+obj.last_name+" - "+obj.email };
			})
			};
		},
		cache: true
	  },
	  escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
	  minimumInputLength: 3,
	  templateResult: wcra_formatRepo, 
	  templateSelection: wcra_formatRepoSelection  
	});
	
} );

function wcra_formatRepo (repo) 
{
	if (repo.loading) return repo.text;
	
	var markup = '<div class="clearfix">' +
			'<div class="col-sm-12">' + repo.text + '</div>';
    markup += '</div>'; 
	
    return markup;
  }

  function wcra_formatRepoSelection (repo) 
  {
	  return repo.full_name || repo.text;
  }